package system

import (
	"sundynix-go/global"
	common "sundynix-go/model/commom/request"
	"sundynix-go/model/system"
	systemReq "sundynix-go/model/system/request"
)

type OperationRecordService struct{}

var OperationRecordServiceApp = new(OperationRecordService)

func (o *OperationRecordService) CreateOperationRecord(operationRecord system.SysOperationRecord) (err error) {
	return global.DB.Create(&operationRecord).Error
}

func (o *OperationRecordService) GetRecordList(info systemReq.GetOperationRecordList) (list interface{}, total int64, err error) {
	limit := info.PageSize
	offset := info.PageSize * (info.Current - 1)
	db := global.DB.Model(&system.SysOperationRecord{})
	var operationRecordList []system.SysOperationRecord

	if info.Ip != "" {
		db = db.Where("ip = ?", info.Method)
	}
	if info.Method != "" {
		db = db.Where("method = ?", info.Method)
	}
	if info.Path != "" {
		db = db.Where("path = ?", info.Path)
	}
	if info.UserId != "" {
		db = db.Where("status = ?", info.UserId)
	}
	if info.Status != 0 {
		db = db.Where("status = ?", info.Status)
	}
	err = db.Count(&total).Error
	if err != nil {
		return
	}
	err = db.Limit(limit).Offset(offset).Find(&operationRecordList).Error
	return operationRecordList, total, err
}

func (o *OperationRecordService) GetRecordById(id string) (record system.SysOperationRecord, err error) {
	var r system.SysOperationRecord
	err = global.DB.Where("id = ?", id).First(&r).Error
	return r, err
}

func (o *OperationRecordService) DeleteRecordsByIds(ids common.IdsReq) (err error) {
	// Unscoped()禁用软删除 --> 永久物理删除
	err = global.DB.Where("id in ?", ids.Ids).Unscoped().Delete(&system.SysOperationRecord{}).Error
	return err
}
